/******************************************************************************

  DADO ELETRNICO DUPLO COM LEDS

  AUTOR:  CLUDIO LRIOS

  DATA: 28-05-2015

  OBJETIVO: SORTEAR NMEROS ALEATRIAMENTE ENTRE 0-6  EM DOIS MOSTRADORES CONS-
  TITUIDOS DE 7 LEDS CADA UM, EM IMITAO A 2 DADOS.

  ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS

  USO DIDTICO APENAS.

  (VERSO CORRIGIDA COM EFEITO 'DE DADO ROLANDO NA MESA AT PARAR')

 ******************************************************************************/

#include <12F675.h>   //microcontrolador 12f675
#device adc=8         //adc8 (obs. adc no usado)
#define RAND_MAX  6  //limite da randomizao (1-6)
#include <STDLIB.H>  //biblioteca para obter randomizao
#use fast_io(a)      //sentido das portas feita pelo programador
#use delay(clock=4000000)  //clock interno
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, NOPUT, NOBROWNOUT //configurao
//#rom 0x3ff = {0x34fc}  //somente em caso de perda do byte de calibrao


//bytes
#byte  gpio    = 0x05  //gpio
#byte  trisio  = 0x85  //trisio
#byte  tmr0    = 0x01  //timer 0
#byte  tmr1l   = 0x0e  //timer 1

//bits
#bit   ftmr1   = 0x0c.0 //flag de over flow do tmr1
#bit   gp0     = 0x05.0 //pino 7
#bit   gp1     = 0x05.1 //pino 6
#bit   gp4     = 0x05.4 //pino 3
#bit   gp5     = 0x05.5 //pino 2
#bit   sw      = 0x05.3 //pino 4
#bit   som     = 0x05.2 //pino 5
#bit   tris0   = 0x85.0 //sentido do pino 7
#bit   tris1   = 0x85.1 //sentido do pino 6
#bit   tris4   = 0x85.4 //sentido do pino 3
#bit   tris5   = 0x85.5 //sentido do pino 2

int8 const tef= 1;
int8 const nap= 10 ;//nmero de pr-apresentaes do resultado simulando dado rolando na mesa
int16 const tap = 1000;
int8   dado_1, dado_2,aux,cnt,cnt1;
int1 tr,fim;


/*******************************************************************************

                       SUB-ROTINAS

*******************************************************************************/


/*******************************************************************************
                       GERA BIPS
*******************************************************************************/
void faz_bip(){
   int16 aa;

     for(aa=0; aa<700; aa++){
       som=1;
       delay_us(110);
       som=0;
       delay_us(110);
      }

}


/*
int8 pega_dado1(){
  int8 a;
  a=tmr1l&0b00000111;
  if(a>5) a=2;
  return(a+1);
}

int8 pega_dado2(){
 int8 a;
  a=tmr0&0b00000111;
  if(a>5){a=2;}
  return (a+1);
}
*/

/*******************************************************************************
                       RANDOMIZA PARA DADO 1
*******************************************************************************/

int8 pega_dado1(){
  return(rand()+1);}
/*******************************************************************************
                       RANDOMIZA PARA DADO 2
*******************************************************************************/

int8 pega_dado2(){
  return(rand()+1);}

/*******************************************************************************
                       MULTIPLEXAO
*******************************************************************************/

void on_led4a(){
    aux=gpio;
    aux&=0b001100;//apaga digitos da mux
    aux|=0b100000;//led4a
    trisio=0b111011;
    gpio=aux;
    trisio=0b001011;//led4a sentido
}

void on_led17a(){
    aux=gpio;
    aux&=0b001100;//apaga digitos da mux
    aux|=0b100000;//led17a
    trisio=0b111011;
    gpio=aux;
    trisio=0b011010;//led17a sentido
}

void on_led26a(){
    aux=gpio;
    aux&=0b001100;//apaga digitos da mux
    aux|=0b000001;//led26a
    trisio=0b111011;
    gpio=aux;
    trisio=0b011010;//led26a sentido


}

void on_led35a(){
    aux=gpio;
    aux&=0b001100;//apaga digitos da mux
    aux|=0b010000;//led35a
    trisio=0b111011;
    gpio=aux;
    trisio=0b001011;//led35a sentido

}



void on_led4b(){
    aux=gpio;
    aux&=0b001100;//apaga digitos da mux
    aux|=0b000010;//led4b
    trisio=0b111011;
    gpio=aux;
    trisio=0b101001;//led4b sentido
}

void on_led17b(){
    aux=gpio;
    aux&=0b001100;//apaga digitos da mux
    aux|=0b000010;//led17b
    trisio=0b111011;
    gpio=aux;
    trisio=0b011000;//led17b sentido
}

void on_led26b(){
    aux=gpio;
    aux&=0b001100;//apaga digitos da mux
    aux|=0b000001;//led26b
    trisio=0b111011;
    gpio=aux;
    trisio=0b111000;//led26b sentido


}

void on_led35b(){
    aux=gpio;
    aux&=0b001100;//apaga digitos da mux
    aux|=0b010000;//led35b
    trisio=0b111011;//apaga leds
    gpio=aux;
    trisio=0b101001;//led35b sentido

}
/*******************************************************************************
         ROTINA PRINCIPAL C/ INICIALIZAO DE PORTAS E REGISTRADORES
*******************************************************************************/
void main() {

   setup_adc_ports(NO_ANALOGS);
   setup_counters(RTCC_INTERNAL,RTCC_DIV_1);
   setup_timer_1(T1_INTERNAL | T1_DIV_BY_1);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   port_a_pullups(FALSE);
   trisio= 0b111011;
   tr=0;
   ftmr1=0;
   fim=0;
/*******************************************************************************
                       LOOP PRINCIPAL
*******************************************************************************/

   while(1){
    if((sw)&&(fim)){tr=0; fim=0;} // testa se acabou o sorteio

     if((!sw)&&(!tr)) {// testa se houve acionamento do boto de sorteio
       tr=1; //trava como sorteio iniciado
       ftmr1=0; //apaga flag do timer 1
       cnt=nap; //carga do  numero de pr-sorteios
       cnt1=tef;//carga do tempo entre pr-sorteios (1=65536 useg)
     }//if(sw)&&(!tr))


    if(tr&&!fim){ // se j est em sorteio
     if(ftmr1){// verifica se houve over flow do timer1
      ftmr1=0;//apaga flag do timer1
      if(!--cnt1){//decrementa contador de tempo
       cnt1=tef+(nap-cnt);//e recarrega novo valor p/ o prximo intervalo entre pr-sorteios
         if(!--cnt){//se j ocorreram todos os pr-sorteios
         int8 a;
           cnt=nap; //recarrega os valores iniciais
           cnt1=tef;
           fim=1;  //seta a finalizao
           trisio= 0b111011; //acerta porta para bipar
           for(a=0;a<5;a++) faz_bip();//bip final mais longo
         }
         else{//bip curto entre pr-sorteios
          trisio= 0b111011;
          faz_bip();
          delay_ms(100);
         }//else
       dado_1= pega_dado1(); // pega valor do prximo pr-sorteio ou o final
       dado_2= pega_dado2();
      }//if(--!cnt1)
     }//if(ftmr1)
    }// if(tr)

/*******************************************************************************
                       LIGA OS LEDS DO DADO 1
*******************************************************************************/

    if(dado_1==1) {on_led4a(); delay_us(tap);}
    if(dado_1==2) {on_led17a(); delay_us(tap);}
    if(dado_1==3) {on_led4a(); delay_us(tap); on_led17a(); delay_us(tap);}
    if(dado_1==4) {on_led26a(); delay_us(tap); on_led17a(); delay_us(tap);}
    if(dado_1==5) {on_led26a(); delay_us(tap); on_led17a(); delay_us(tap); on_led4a(); delay_us(tap);}
    if(dado_1==6) {on_led17a(); delay_us(tap); on_led35a(); delay_us(tap); on_led26a(); delay_us(tap);}
/*******************************************************************************
                       LIGA OS LEDS DO DADO 2
*******************************************************************************/

    if(dado_2==1) {on_led4b(); delay_us(tap);}
    if(dado_2==2) {on_led17b(); delay_us(tap);}
    if(dado_2==3) {on_led4b(); delay_us(tap); on_led17b(); delay_us(tap);}
    if(dado_2==4) {on_led26b(); delay_us(tap); on_led17b(); delay_us(tap);}
    if(dado_2==5) {on_led26b(); delay_us(tap); on_led17b(); delay_us(tap); on_led4b(); delay_us(tap);}
    if(dado_2==6) {on_led17b(); delay_us(tap); on_led35b(); delay_us(tap); on_led26b(); delay_us(tap);}

   }//while(1)
}//main
